"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styleConst = require("@cloudflare/style-const");

var _raf = _interopRequireDefault(require("raf"));

var _styleContainer = require("@cloudflare/style-container");

var _componentIcon = require("@cloudflare/component-icon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var getBorderColor = function getBorderColor(type, theme) {
  switch (type) {
    case 'success':
      return theme.colors.green[5];

    case 'warning':
      return theme.colors.orange[5];

    case 'error':
      return theme.colors.red[2];

    case 'info':
    default:
      return theme.colors.blue[3];
  }
};

var getBackgroundColor = function getBackgroundColor(type, theme) {
  switch (type) {
    case 'success':
      return theme.colors.green[(0, _styleConst.isDarkMode)() ? 3 : 6];

    case 'warning':
      return theme.colors.orange[(0, _styleConst.isDarkMode)() ? 3 : 6];

    case 'error':
      return theme.colors.red[3];

    case 'info':
    default:
      return theme.colors.blue[(0, _styleConst.isDarkMode)() ? 3 : 6];
  }
};

var NotificationMessage = (0, _styleContainer.createComponent)(function (_ref) {
  var theme = _ref.theme;
  return {
    position: 'relative',
    zIndex: 2,
    color: theme.colors.white,
    display: 'flex',
    alignItems: 'center'
  };
}, 'span');
var NotificationClose = (0, _styleContainer.createComponent)(function (_ref2) {
  var theme = _ref2.theme,
      type = _ref2.type;
  return {
    position: 'absolute',
    zIndex: 3,
    top: 0,
    right: 0,
    bottom: 0,
    width: '2.5em',
    cursor: 'pointer',
    '&:hover': {
      backgroundColor: getBorderColor(type, theme)
    },
    '&::before': {
      position: 'absolute',
      top: '50%',
      left: '50%',
      transform: 'translate(-50%, -50%)'
    }
  };
}, 'span');
var NotificationContainer = (0, _styleContainer.createComponent)(function (_ref3) {
  var theme = _ref3.theme,
      type = _ref3.type;
  return {
    position: 'relative',
    padding: theme.space[2],
    verticalAlign: 'middle',
    '-webkit-text-stroke': '0',
    '-webkit-font-smoothing': 'antialiased',
    cursor: 'pointer',
    transformOrigin: 'bottom left',
    borderTopColor: getBorderColor(type, theme),
    borderBottomColor: getBorderColor(type, theme),
    borderLeftColor: getBorderColor(type, theme),
    borderRightColor: getBorderColor(type, theme),
    borderTopWidth: 1,
    borderRightWidth: 1,
    borderBottomWidth: 0,
    borderLeftWidth: 1,
    borderStyle: 'solid',
    backgroundColor: getBackgroundColor(type, theme),
    animationName: {
      '0%': {
        transform: 'scaleY(0)'
      },
      '100%': {
        transform: 'scaleY(1)'
      }
    },
    animationDuration: '200ms',
    animationTimingFunction: 'ease-in-out',
    '&::before': {
      position: 'absolute',
      top: '50%',
      left: '0.75rem',
      transform: 'translate(0, -50%)',
      lineHeight: '1',
      verticalAlign: 'middle'
    },
    '&:first-child': {
      borderTopWidth: 1
    }
  };
}, 'div');
var IconWrapper = (0, _styleContainer.createComponent)(function () {
  return {
    paddingRight: 6,
    display: 'flex'
  };
});
var NotificationWrapper = (0, _styleContainer.createComponent)(function () {
  return {
    display: 'flex'
  };
});
var CloseWrapper = (0, _styleContainer.createComponent)(function () {
  return {
    position: 'absolute',
    top: '50%',
    left: '50%',
    transform: 'translate(-50%,-50%)'
  };
});
var NotificationItem = (0, _styleContainer.createComponent)(function () {
  return {};
}, function (_ref4) {
  var children = _ref4.children,
      closable = _ref4.closable,
      handleClickClose = _ref4.handleClickClose,
      type = _ref4.type;
  var iconType;

  switch (type) {
    case 'success':
      iconType = 'ok-sign';
      break;

    case 'info':
      iconType = 'info-sign';
      break;

    case 'warning':
      iconType = 'exclamation-sign';
      break;

    case 'error':
      iconType = 'exclamation-sign';
      break;

    default:
      iconType = 'info-sign';
      break;
  }

  return /*#__PURE__*/_react.default.createElement(NotificationWrapper, null, /*#__PURE__*/_react.default.createElement(NotificationMessage, null, /*#__PURE__*/_react.default.createElement(IconWrapper, null, /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, {
    type: iconType,
    label: type ? type : 'info-sign',
    color: "white",
    size: 24
  })), children), closable && /*#__PURE__*/_react.default.createElement(NotificationClose, {
    onClick: handleClickClose,
    type: type
  }, /*#__PURE__*/_react.default.createElement(CloseWrapper, null, /*#__PURE__*/_react.default.createElement(_componentIcon.Icon, {
    type: "remove",
    label: "close",
    color: "white"
  }))));
});
NotificationItem.propTypes = {
  children: _propTypes.default.string,
  closable: _propTypes.default.bool,
  persist: _propTypes.default.bool,
  duration: _propTypes.default.number,
  active: _propTypes.default.bool,
  handleClickClose: _propTypes.default.func
};

var Notification = /*#__PURE__*/function (_React$Component) {
  _inherits(Notification, _React$Component);

  var _super = _createSuper(Notification);

  function Notification(props) {
    var _this;

    _classCallCheck(this, Notification);

    _this = _super.call(this, props);
    _this.state = {
      persist: _this.props.persist,
      timeoutId: null
    };
    return _this;
  }

  _createClass(Notification, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      // Read this https://stanko.github.io/react-rerender-in-component-did-mount/
      this._raf = (0, _raf.default)(function () {
        _this2._raf = (0, _raf.default)(function () {
          _this2._raf = null;

          _this2.startTimeout();
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.stopTimeout();
    }
  }, {
    key: "startTimeout",
    value: function startTimeout() {
      var _this3 = this;

      // Don't dismiss errors if they're configured to be persisted,
      // or if we're in a testing environment
      if (this.state.persist || process.env.TESTING) {
        return;
      }

      this.stopTimeout();
      var timeoutId = setTimeout(function () {
        return _this3.props.onClose();
      }, this.props.delay);
      this.setState({
        timeoutId: timeoutId
      });
    }
  }, {
    key: "stopTimeout",
    value: function stopTimeout() {
      if (this._raf) {
        _raf.default.cancel(this._raf);

        this._raf = null;
      }

      if (this.state.timeoutId) {
        clearTimeout(this.state.timeoutId);
        this.setState({
          timeoutId: null
        });
      }
    }
  }, {
    key: "handleMouseEnter",
    value: function handleMouseEnter() {
      this.stopTimeout();
    }
  }, {
    key: "handleMouseLeave",
    value: function handleMouseLeave() {
      this.startTimeout();
    }
  }, {
    key: "handleClickClose",
    value: function handleClickClose() {
      this.props.onClose();
    }
  }, {
    key: "handleClick",
    value: function handleClick() {
      this.stopTimeout();
      this.setState({
        persist: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(NotificationContainer, {
        role: "alert",
        onClick: this.handleClick.bind(this),
        onMouseEnter: this.handleMouseEnter.bind(this),
        onMouseLeave: this.handleMouseLeave.bind(this),
        type: this.props.type
      }, /*#__PURE__*/_react.default.createElement(NotificationItem, {
        closable: this.props.closable,
        handleClickClose: this.handleClickClose.bind(this),
        duration: this.props.delay,
        persist: this.state.persist,
        active: !!this.state.timeoutId,
        type: this.props.type
      }, this.props.message));
    }
  }]);

  return Notification;
}(_react.default.Component);

Notification.propTypes = {
  type: _propTypes.default.oneOf(['success', 'error', 'info', 'warning']),
  message: _propTypes.default.string.isRequired,
  closable: _propTypes.default.bool,
  delay: _propTypes.default.number,
  persist: _propTypes.default.bool,
  onClose: _propTypes.default.func.isRequired
};
Notification.defaultProps = {
  closable: true,
  delay: 4000,
  persist: false,
  type: 'info'
};
var _default = Notification;
exports.default = _default;