import React from 'react';
import PropTypes from 'prop-types';
import { createComponent } from '@cloudflare/style-container';

const styles = ({ theme }) => ({
  position: 'fixed',
  bottom: 0,
  left: 0,
  right: 0,
  maxHeight: '25%',
  overflow: 'auto',
  zIndex: 1600,
  fontSize: theme.fontSizes[3]
});

const NotificationGlobalContainer = ({ className, children }) => (
  <div className={className}>{children}</div>
);

NotificationGlobalContainer.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string
};
NotificationGlobalContainer.displayName = 'NotificationGlobalContainer';

export default createComponent(styles, NotificationGlobalContainer);
